import nltk
import re

nltk.download('punkt')

emoji_dict = {
    "😊": "হাসি",
    "😢": "কান্না",
    "😠": "রাগ",
    "😔": "মন খারাপ",
    "👍": "দারুণ",
    "😎": "ঠান্ডা",
    "😭": "অশ্রু",
    "😁": "মুচকি হাসি",
    "😅": "হালকা হাসি",
    "😍": "ভালবাসা",
    "😒": "অসন্তুষ্ট",
    "😞": "হতাশা",
    "😡": "রাগান্বিত",
    "😃": "খুশি",
    "😉": "চোখ মারা",
    "😋": "স্বাদ আস্বাদন",
    "😐": "নির্বিকার",
    "😤": "অসন্তুষ্ট",
    "😴": "ঘুম",
    "😜": "মজার",
    "😩": "ক্লান্ত",
    "😯": "আশ্চর্য",
    "😆": "হাসি",
    "😷": "মাস্ক",
    "🙄": "গুর্গুরানি",
    "😳": "বিস্মিত",
    "😬": "চিন্তিত",
    "😚": "চুম্বন",
    "😰": "উদ্বিগ্ন",
    "🤗": "আলিঙ্গন",
    "🤔": "চিন্তাশীল",
    "🤐": "মুখ বন্ধ",
    "😇": "পুণ্যবান"
}

bn_stopwords = ['আমি', 'আপনি', 'সে', 'তুমি', 'আমরা', 'আপনারা', 'তারা', 'এর', 'এই', 'ওই', 'তার', 'তাদের', 'আমাদের', 'আপনার', 'তোমার', 'আপনারা', 'আমরা', 'যে', 'যত', 'সব', 'কিছু', 'বহু', 'কোনো', 'কোন', 'একটি', 'এটি', 'তিন', 'চার', 'এখানে', 'যেখানে', 'এখানে', 'কিভাবে', 'কীভাবে', 'কেন', 'কেননা', 'যখন', 'যদি', 'তবে', 'কিন্তু', 'তবে', 'আর', 'তিন', 'চার', 'অথবা', 'নাহলে', 'যত', 'যেমন', 'কিন্তু', 'নিশ্চিত', 'সবাই', 'অনেক', 'কিছু', 'কেননা', 'অন্য', 'নতুন', 'পুরানো', 'বেশি', 'কম', 'অন্তত', 'বেশি', 'কম', 'এবং', 'অথবা', 'নির্বাচন', 'এই', 'ওই', 'ফিরে', 'তারপর', 'পরে', 'আগে', 'তখন', 'নতুন', 'পুরানো', 'যে', 'তবে', 'অথবা', 'একটি', 'অথবা', 'অবশ্য', 'এরপর', 'আমরা', 'বিভিন্ন', 'সকল', 'যেখানে', 'এখানে', 'কি', 'মাঝে', 'মধ্যে', 'মধ্যবর্তী', 'যে', 'শুধু', 'উল্লেখযোগ্য', 'অধিক', 'যেমন', 'বিভিন্ন', 'অপর', 'অন্য', 'কিছু', 'অন্যান্য', 'আর', 'যাওয়া', 'আসা', 'কী', 'যখন', 'এটি', 'কারণে', 'তারপর', 'তাদের', 'আমাদের', 'আরও', 'অবশ্যই', 'এবং', 'অথবা', 'বিশেষ', 'কি', 'ব্যাপারে', 'অথবা', 'দ্বারা', 'তারা', 'এক', 'মধ্যে', 'কিছু', 'তবে', 'এছাড়া', 'মধ্যে', 'কোনো', 'অন্য', 'প্রতিটি', 'একটি', 'যেখানে', 'যত', 'যে', 'যদি', 'আর', 'অনেক', 'যেমন', 'যেমন', 'তার', 'ভেতরে', 'দ্বারা', 'এর', 'আছে', 'দিয়ে', 'যাওয়া', 'আসা', 'যে', 'নতুন', 'পুরানো', 'যেমন', 'ফিরে', 'পরের', 'সকল', 'তাদের', 'সব', 'অন্যান্য', 'আরও', 'কোন', 'এখানে', 'যখন', 'তবে', 'তাদের', 'ফিরে', 'যেখানে', 'আরও', 'আমরা', 'কিছু', 'অন্য', 'নতুন', 'কিছু', 'অন্য', 'সবার', 'অপর', 'মাঝে', 'বিভিন্ন', 'এই', 'তাদের', 'আমাদের', 'এই', 'যেমন', 'অতএব', 'এরপর', 'নতুন', 'সর্বোচ্চ', 'সর্বনিম্ন', 'মাঝে', 'আমি', 'আপনি', 'সে', 'তুমি', 'আমরা', 'আপনারা', 'তারা', 'এর', 'এই', 'ওই', 'তার', 'তাদের', 'আমাদের', 'আপনার', 'তোমার', 'আপনারা', 'আমরা', 'যে', 'যত', 'সব', 'কিছু', 'বহু', 'কোনো', 'কোন', 'একটি', 'এটি', 'তিন', 'চার', 'এখানে', 'যেখানে', 'এখানে', 'কিভাবে', 'কীভাবে', 'কেন', 'কেননা', 'যখন', 'যদি', 'তবে', 'কিন্তু', 'তবে', 'আর', 'তিন', 'চার', 'অথবা', 'নাহলে', 'যত', 'যেমন', 'কিন্তু', 'নিশ্চিত', 'সবাই', 'অনেক', 'কিছু', 'কেননা', 'অন্য', 'নতুন', 'পুরানো', 'বেশি', 'কম', 'অন্তত', 'বেশি', 'কম', 'এবং', 'অথবা', 'নির্বাচন', 'এই', 'ওই', 'ফিরে', 'তারপর', 'পরে', 'আগে', 'তখন', 'নতুন', 'পুরানো', 'যে', 'তবে', 'অথবা', 'একটি', 'অথবা', 'অবশ্য', 'এরপর', 'আমরা', 'বিভিন্ন', 'সকল', 'যেখানে', 'এখানে', 'কি', 'মাঝে', 'মধ্যে', 'মধ্যবর্তী', 'যে', 'শুধু', 'উল্লেখযোগ্য', 'অধিক', 'যেমন', 'বিভিন্ন', 'অপর', 'অন্য', 'কিছু', 'অন্যান্য', 'আর', 'যাওয়া', 'আসা', 'কী', 'যখন', 'এটি', 'কারণে', 'তারপর', 'তাদের', 'আমাদের', 'আরও', 'অবশ্যই', 'এবং', 'অথবা', 'বিশেষ', 'কি', 'ব্যাপারে', 'অথবা', 'দ্বারা', 'তারা', 'এক', 'মধ্যে', 'কিছু', 'তবে', 'এছাড়া', 'মধ্যে', 'কোনো', 'অন্য', 'প্রতিটি', 'একটি', 'যেখানে', 'যত', 'যে', 'যদি', 'আর', 'অনেক', 'যেমন', 'যেমন', 'তার', 'ভেতরে', 'দ্বারা', 'এর', 'আছে', 'দিয়ে', 'যাওয়া', 'আসা', 'যে', 'নতুন', 'পুরানো', 'যেমন', 'ফিরে', 'পরের', 'সকল', 'তাদের', 'সব', 'অন্যান্য', 'আরও', 'কোন', 'এখানে', 'যখন', 'তবে', 'তাদের', 'ফিরে', 'যেখানে', 'আরও', 'আমরা', 'কিছু', 'অন্য', 'নতুন', 'কিছু', 'অন্য', 'সবার', 'অপর', 'মাঝে', 'বিভিন্ন', 'এই', 'তাদের', 'আমাদের', 'এই', 'যেমন', 'অতএব', 'এরপর', 'নতুন', 'সর্বোচ্চ', 'সর্বনিম্ন', 'মাঝে', 'আমি', 'আপনি', 'সে', 'তুমি', 'আমরা', 'আপনারা', 'তারা', 'এর', 'এই', 'ওই', 'তার', 'তাদের', 'আমাদের', 'আপনার', 'তোমার', 'আপনারা', 'আমরা', 'যে', 'যত', 'সব', 'কিছু', 'বহু', 'কোনো', 'কোন', 'একটি', 'এটি', 'তিন', 'চার', 'এখানে', 'যেখানে', 'এখানে', 'কিভাবে', 'কীভাবে', 'কেন', 'কেননা', 'যখন', 'যদি', 'তবে', 'কিন্তু', 'তবে', 'আর', 'তিন', 'চার', 'অথবা', 'নাহলে', 'যত', 'যেমন', 'কিন্তু', 'নিশ্চিত', 'সবাই', 'অনেক', 'কিছু', 'কেননা', 'অন্য', 'নতুন', 'পুরানো', 'বেশি', 'কম', 'অন্তত', 'বেশি', 'কম', 'এবং', 'অথবা', 'নির্বাচন', 'এই', 'ওই', 'ফিরে', 'তারপর', 'পরে', 'আগে', 'তখন', 'নতুন', 'পুরানো', 'যে', 'তবে', 'অথবা', 'একটি', 'অথবা', 'অবশ্য', 'এরপর', 'আমরা', 'বিভিন্ন', 'সকল', 'যেখানে', 'এখানে', 'কি', 'মাঝে', 'মধ্যে', 'মধ্যবর্তী', 'যে', 'শুধু', 'উল্লেখযোগ্য', 'অধিক', 'যেমন', 'বিভিন্ন', 'অপর', 'অন্য', 'কিছু', 'অন্যান্য', 'আর', 'যাওয়া', 'আসা', 'কী', 'যখন', 'এটি', 'কারণে', 'তারপর', 'তাদের', 'আমাদের', 'আরও', 'অবশ্যই', 'এবং', 'অথবা', 'বিশেষ', 'কি', 'ব্যাপারে', 'অথবা', 'দ্বারা', 'তারা', 'এক', 'মধ্যে', 'কিছু', 'তবে', 'এছাড়া', 'মধ্যে', 'কোনো', 'অন্য', 'প্রতিটি', 'একটি', 'যেখানে', 'যত', 'যে', 'যদি', 'আর', 'অনেক', 'যেমন', 'যেমন', 'তার', 'ভেতরে', 'দ্বারা', 'এর', 'আছে', 'দিয়ে', 'যাওয়া', 'আসা', 'যে', 'নতুন', 'পুরানো', 'যেমন', 'ফিরে', 'পরের', 'সকল', 'তাদের', 'সব', 'অন্যান্য', 'আরও', 'কোন', 'এখানে', 'যখন', 'তবে', 'তাদের', 'ফিরে', 'যেখানে', 'আরও', 'আমরা', 'কিছু', 'অন্য', 'নতুন', 'কিছু', 'অন্য', 'সবার', 'অপর', 'মাঝে', 'বিভিন্ন', 'এই', 'তাদের', 'আমাদের', 'এই', 'যেমন', 'অতএব', 'এরপর', 'নতুন', 'সর্বোচ্চ', 'সর্বনিম্ন', 'মাঝে', 'অতএব', 'অথচ', 'অথবা', 'অনুযায়ী', 'অনেক', 'অনেকে', 'অনেকেই', 'অন্তত', 'অন্য', 'অবধি', 'অবশ্য', 'অর্থাত', 'আই', 'আগামী', 'আগে', 'আগেই', 'আছে', 'আজ', 'আদ্যভাগে', 'আপনার', 'আপনি', 'আবার', 'আমরা', 'আমাকে', 'আমাদের', 'আমার', 'আমি', 'আর', 'আরও', 'ই', 'ইত্যাদি', 'ইহা', 'উচিত', 'উত্তর', 'উনি', 'উপর', 'উপরে', 'এ', 'এঁদের', 'এঁরা', 'এই', 'একই', 'একটি', 'একবার', 'একে', 'এক্', 'এখন', 'এখনও', 'এখানে', 'এখানেই', 'এটা', 'এটাই', 'এটি', 'এত', 'এতটাই', 'এতে', 'এদের', 'এব', 'এবং', 'এবার', 'এমন', 'এমনকী', 'এমনি', 'এর', 'এরা', 'এল', 'এস', 'এসে', 'ঐ', 'ও', 'ওঁদের', 'ওঁর', 'ওঁরা', 'ওই', 'ওকে', 'ওখানে', 'ওদের', 'ওর', 'ওরা', 'কখনও', 'কত', 'কবে', 'কমনে', 'কয়েক', 'কয়েকটি', 'করছে', 'করছেন', 'করতে', 'করবে', 'করবেন', 'করলে', 'করলেন', 'করা', 'করাই', 'করায়', 'করার', 'করি', 'করিতে', 'করিয়া', 'করিয়ে', 'করে', 'করেই', 'করেছিলেন', 'করেছে', 'করেছেন', 'করেন', 'কাউকে', 'কাছ', 'কাছে', 'কাজ', 'কাজে', 'কারও', 'কারণ', 'কি', 'কিংবা', 'কিছু', 'কিছুই', 'কিন্তু', 'কী', 'কে', 'কেউ', 'কেউই', 'কেখা', 'কেন', 'কোটি', 'কোন', 'কোনও', 'কোনো', 'ক্ষেত্রে', 'কয়েক', 'খুব', 'গিয়ে', 'গিয়েছে', 'গিয়ে', 'গুলি', 'গেছে', 'গেল', 'গেলে', 'গোটা', 'চলে', 'চান', 'চায়', 'চার', 'চালু', 'চেয়ে', 'চেষ্টা', 'ছাড়া', 'ছাড়াও', 'ছিল', 'ছিলেন', 'জন', 'জনকে', 'জনের', 'জন্য', 'জন্যওজে', 'জানতে', 'জানা', 'জানানো', 'জানায়', 'জানিয়ে', 'জানিয়েছে', 'জে', 'জ্নজন', 'টি', 'ঠিক', 'তখন', 'তত', 'তথা', 'তবু', 'তবে', 'তা', 'তাঁকে', 'তাঁদের', 'তাঁর', 'তাঁরা', 'তাঁাহারা', 'তাই', 'তাও', 'তাকে', 'তাতে', 'তাদের', 'তার', 'তারপর', 'তারা', 'তারৈ', 'তাহলে', 'তাহা', 'তাহাতে', 'তাহার', 'তিনঐ', 'তিনি', 'তিনিও', 'তুমি', 'তুলে', 'তেমন', 'তো', 'তোমার', 'থাকবে', 'থাকবেন', 'থাকা', 'থাকায়', 'থাকে', 'থাকেন', 'থেকে', 'থেকেই', 'থেকেও', 'দিকে', 'দিতে', 'দিন', 'দিয়ে', 'দিয়েছে', 'দিয়েছেন', 'দিলেন', 'দু', 'দুই', 'দুটি', 'দুটো', 'দেওয়া', 'দেওয়ার', 'দেওয়া', 'দেখতে', 'দেখা', 'দেখে', 'দেন', 'দেয়', 'দ্বারা', 'ধরা', 'ধরে', 'ধামার', 'নতুন', 'নয়', 'না', 'নাই', 'নাকি', 'নাগাদ', 'নানা', 'নিজে', 'নিজেই', 'নিজেদের', 'নিজের', 'নিতে', 'নিয়ে', 'নিয়ে', 'নেই', 'নেওয়া', 'নেওয়ার', 'নেওয়া', 'নয়', 'পক্ষে', 'পর', 'পরে', 'পরেই', 'পরেও', 'পর্যন্ত', 'পাওয়া', 'পাচ', 'পারি', 'পারে', 'পারেন', 'পি', 'পেয়ে', 'পেয়্র্', 'প্রতি', 'প্রথম', 'প্রভৃতি', 'প্রযন্ত', 'প্রাথমিক', 'প্রায়', 'প্রায়', 'ফলে', 'ফিরে', 'ফের', 'বক্তব্য', 'বদলে', 'বন', 'বরং', 'বলতে', 'বলল', 'বললেন', 'বলা', 'বলে', 'বলেছেন', 'বলেন', 'বসে', 'বহু', 'বা', 'বাদে', 'বার', 'বি', 'বিনা', 'বিভিন্ন', 'বিশেষ', 'বিষয়টি', 'বেশ', 'বেশি', 'ব্যবহার', 'ব্যাপারে', 'ভাবে', 'ভাবেই', 'মতো', 'মতোই', 'মধ্যভাগে', 'মধ্যে', 'মধ্যেই', 'মধ্যেও', 'মনে', 'মাত্র', 'মাধ্যমে', 'মোট', 'মোটেই', 'যখন', 'যত', 'যতটা', 'যথেষ্ট', 'যদি', 'যদিও', 'যা', 'যাঁর', 'যাঁরা', 'যাওয়া', 'যাওয়ার', 'যাওয়া', 'যাকে', 'যাচ্ছে', 'যাতে', 'যাদের', 'যান', 'যাবে', 'যায়', 'যার', 'যারা', 'যিনি', 'যে', 'যেখানে', 'যেতে', 'যেন', 'যেমন', 'র', 'রকম', 'রয়েছে', 'রাখা', 'রেখে', 'লক্ষ', 'শুধু', 'শুরু', 'সঙ্গে', 'সঙ্গেও', 'সব', 'সবার', 'সমস্ত', 'সম্প্রতি', 'সহ', 'সহিত', 'সাধারণ', 'সামনে', 'সি', 'সুতরাং', 'সে', 'সেই', 'সেখান', 'সেখানে', 'সেটা', 'সেটাই', 'সেটাও', 'সেটি', 'স্পষ্ট', 'স্বয়ং', 'হইতে', 'হইবে', 'হইয়া', 'হওয়া', 'হওয়ায়', 'হওয়ার', 'হচ্ছে', 'হত', 'হতে', 'হতেই', 'হন', 'হবে', 'হবেন', 'হয়', 'হয়তো', 'হয়নি', 'হয়ে', 'হয়েই', 'হয়েছিল', 'হয়েছে', 'হয়েছেন', 'হল', 'হলে', 'হলেই', 'হলেও', 'হলো', 'হাজার', 'হিসাবে', 'হৈলে', 'হোক', 'হয়']

def remove_stopwords(text):
    words = nltk.word_tokenize(text)
    filtered_words = [word for word in words if word not in bn_stopwords]
    return ' '.join(filtered_words)

def remove_non_bangla_words(text):
    return ' '.join([word for word in text.split() if all('ঀ' <= c <= '৿' for c in word)])

def remove_null_characters(text):
    return text.replace('\x00', '')

def remove_urls(text):
    url_pattern = re.compile(r'https?://\S+|www\.\S+')
    return url_pattern.sub(r'', text)

def replace_emojis(text):
    for emoji, meaning in emoji_dict.items():
        text = text.replace(emoji, meaning)
    return text

def preprocess_text(text):
    text = replace_emojis(text)
    text = remove_stopwords(text)
    text = remove_non_bangla_words(text)
    text = remove_null_characters(text)
    text = remove_urls(text)
    return text
import nltk
import re

nltk.download('punkt')

emoji_dict = {
    "😊": "হাসি",
    "😢": "কান্না",
    "😠": "রাগ",
    "😔": "মন খারাপ",
    "👍": "দারুণ",
    "😎": "ঠান্ডা",
    "😭": "অশ্রু",
    "😁": "মুচকি হাসি",
    "😅": "হালকা হাসি",
    "😍": "ভালবাসা",
    "😒": "অসন্তুষ্ট",
    "😞": "হতাশা",
    "😡": "রাগান্বিত",
    "😃": "খুশি",
    "😉": "চোখ মারা",
    "😋": "স্বাদ আস্বাদন",
    "😐": "নির্বিকার",
    "😤": "অসন্তুষ্ট",
    "😴": "ঘুম",
    "😜": "মজার",
    "😩": "ক্লান্ত",
    "😯": "আশ্চর্য",
    "😆": "হাসি",
    "😷": "মাস্ক",
    "🙄": "গুর্গুরানি",
    "😳": "বিস্মিত",
    "😬": "চিন্তিত",
    "😚": "চুম্বন",
    "😰": "উদ্বিগ্ন",
    "🤗": "আলিঙ্গন",
    "🤔": "চিন্তাশীল",
    "🤐": "মুখ বন্ধ",
    "😇": "পুণ্যবান"
}

bn_stopwords = ['আমি', 'আপনি', 'সে', 'তুমি', 'আমরা', 'আপনারা', 'তারা', 'এর', 'এই', 'ওই', 'তার', 'তাদের', 'আমাদের', 'আপনার', 'তোমার', 'আপনারা', 'আমরা', 'যে', 'যত', 'সব', 'কিছু', 'বহু', 'কোনো', 'কোন', 'একটি', 'এটি', 'তিন', 'চার', 'এখানে', 'যেখানে', 'এখানে', 'কিভাবে', 'কীভাবে', 'কেন', 'কেননা', 'যখন', 'যদি', 'তবে', 'কিন্তু', 'তবে', 'আর', 'তিন', 'চার', 'অথবা', 'নাহলে', 'যত', 'যেমন', 'কিন্তু', 'নিশ্চিত', 'সবাই', 'অনেক', 'কিছু', 'কেননা', 'অন্য', 'নতুন', 'পুরানো', 'বেশি', 'কম', 'অন্তত', 'বেশি', 'কম', 'এবং', 'অথবা', 'নির্বাচন', 'এই', 'ওই', 'ফিরে', 'তারপর', 'পরে', 'আগে', 'তখন', 'নতুন', 'পুরানো', 'যে', 'তবে', 'অথবা', 'একটি', 'অথবা', 'অবশ্য', 'এরপর', 'আমরা', 'বিভিন্ন', 'সকল', 'যেখানে', 'এখানে', 'কি', 'মাঝে', 'মধ্যে', 'মধ্যবর্তী', 'যে', 'শুধু', 'উল্লেখযোগ্য', 'অধিক', 'যেমন', 'বিভিন্ন', 'অপর', 'অন্য', 'কিছু', 'অন্যান্য', 'আর', 'যাওয়া', 'আসা', 'কী', 'যখন', 'এটি', 'কারণে', 'তারপর', 'তাদের', 'আমাদের', 'আরও', 'অবশ্যই', 'এবং', 'অথবা', 'বিশেষ', 'কি', 'ব্যাপারে', 'অথবা', 'দ্বারা', 'তারা', 'এক', 'মধ্যে', 'কিছু', 'তবে', 'এছাড়া', 'মধ্যে', 'কোনো', 'অন্য', 'প্রতিটি', 'একটি', 'যেখানে', 'যত', 'যে', 'যদি', 'আর', 'অনেক', 'যেমন', 'যেমন', 'তার', 'ভেতরে', 'দ্বারা', 'এর', 'আছে', 'দিয়ে', 'যাওয়া', 'আসা', 'যে', 'নতুন', 'পুরানো', 'যেমন', 'ফিরে', 'পরের', 'সকল', 'তাদের', 'সব', 'অন্যান্য', 'আরও', 'কোন', 'এখানে', 'যখন', 'তবে', 'তাদের', 'ফিরে', 'যেখানে', 'আরও', 'আমরা', 'কিছু', 'অন্য', 'নতুন', 'কিছু', 'অন্য', 'সবার', 'অপর', 'মাঝে', 'বিভিন্ন', 'এই', 'তাদের', 'আমাদের', 'এই', 'যেমন', 'অতএব', 'এরপর', 'নতুন', 'সর্বোচ্চ', 'সর্বনিম্ন', 'মাঝে', 'আমি', 'আপনি', 'সে', 'তুমি', 'আমরা', 'আপনারা', 'তারা', 'এর', 'এই', 'ওই', 'তার', 'তাদের', 'আমাদের', 'আপনার', 'তোমার', 'আপনারা', 'আমরা', 'যে', 'যত', 'সব', 'কিছু', 'বহু', 'কোনো', 'কোন', 'একটি', 'এটি', 'তিন', 'চার', 'এখানে', 'যেখানে', 'এখানে', 'কিভাবে', 'কীভাবে', 'কেন', 'কেননা', 'যখন', 'যদি', 'তবে', 'কিন্তু', 'তবে', 'আর', 'তিন', 'চার', 'অথবা', 'নাহলে', 'যত', 'যেমন', 'কিন্তু', 'নিশ্চিত', 'সবাই', 'অনেক', 'কিছু', 'কেননা', 'অন্য', 'নতুন', 'পুরানো', 'বেশি', 'কম', 'অন্তত', 'বেশি', 'কম', 'এবং', 'অথবা', 'নির্বাচন', 'এই', 'ওই', 'ফিরে', 'তারপর', 'পরে', 'আগে', 'তখন', 'নতুন', 'পুরানো', 'যে', 'তবে', 'অথবা', 'একটি', 'অথবা', 'অবশ্য', 'এরপর', 'আমরা', 'বিভিন্ন', 'সকল', 'যেখানে', 'এখানে', 'কি', 'মাঝে', 'মধ্যে', 'মধ্যবর্তী', 'যে', 'শুধু', 'উল্লেখযোগ্য', 'অধিক', 'যেমন', 'বিভিন্ন', 'অপর', 'অন্য', 'কিছু', 'অন্যান্য', 'আর', 'যাওয়া', 'আসা', 'কী', 'যখন', 'এটি', 'কারণে', 'তারপর', 'তাদের', 'আমাদের', 'আরও', 'অবশ্যই', 'এবং', 'অথবা', 'বিশেষ', 'কি', 'ব্যাপারে', 'অথবা', 'দ্বারা', 'তারা', 'এক', 'মধ্যে', 'কিছু', 'তবে', 'এছাড়া', 'মধ্যে', 'কোনো', 'অন্য', 'প্রতিটি', 'একটি', 'যেখানে', 'যত', 'যে', 'যদি', 'আর', 'অনেক', 'যেমন', 'যেমন', 'তার', 'ভেতরে', 'দ্বারা', 'এর', 'আছে', 'দিয়ে', 'যাওয়া', 'আসা', 'যে', 'নতুন', 'পুরানো', 'যেমন', 'ফিরে', 'পরের', 'সকল', 'তাদের', 'সব', 'অন্যান্য', 'আরও', 'কোন', 'এখানে', 'যখন', 'তবে', 'তাদের', 'ফিরে', 'যেখানে', 'আরও', 'আমরা', 'কিছু', 'অন্য', 'নতুন', 'কিছু', 'অন্য', 'সবার', 'অপর', 'মাঝে', 'বিভিন্ন', 'এই', 'তাদের', 'আমাদের', 'এই', 'যেমন', 'অতএব', 'এরপর', 'নতুন', 'সর্বোচ্চ', 'সর্বনিম্ন', 'মাঝে', 'আমি', 'আপনি', 'সে', 'তুমি', 'আমরা', 'আপনারা', 'তারা', 'এর', 'এই', 'ওই', 'তার', 'তাদের', 'আমাদের', 'আপনার', 'তোমার', 'আপনারা', 'আমরা', 'যে', 'যত', 'সব', 'কিছু', 'বহু', 'কোনো', 'কোন', 'একটি', 'এটি', 'তিন', 'চার', 'এখানে', 'যেখানে', 'এখানে', 'কিভাবে', 'কীভাবে', 'কেন', 'কেননা', 'যখন', 'যদি', 'তবে', 'কিন্তু', 'তবে', 'আর', 'তিন', 'চার', 'অথবা', 'নাহলে', 'যত', 'যেমন', 'কিন্তু', 'নিশ্চিত', 'সবাই', 'অনেক', 'কিছু', 'কেননা', 'অন্য', 'নতুন', 'পুরানো', 'বেশি', 'কম', 'অন্তত', 'বেশি', 'কম', 'এবং', 'অথবা', 'নির্বাচন', 'এই', 'ওই', 'ফিরে', 'তারপর', 'পরে', 'আগে', 'তখন', 'নতুন', 'পুরানো', 'যে', 'তবে', 'অথবা', 'একটি', 'অথবা', 'অবশ্য', 'এরপর', 'আমরা', 'বিভিন্ন', 'সকল', 'যেখানে', 'এখানে', 'কি', 'মাঝে', 'মধ্যে', 'মধ্যবর্তী', 'যে', 'শুধু', 'উল্লেখযোগ্য', 'অধিক', 'যেমন', 'বিভিন্ন', 'অপর', 'অন্য', 'কিছু', 'অন্যান্য', 'আর', 'যাওয়া', 'আসা', 'কী', 'যখন', 'এটি', 'কারণে', 'তারপর', 'তাদের', 'আমাদের', 'আরও', 'অবশ্যই', 'এবং', 'অথবা', 'বিশেষ', 'কি', 'ব্যাপারে', 'অথবা', 'দ্বারা', 'তারা', 'এক', 'মধ্যে', 'কিছু', 'তবে', 'এছাড়া', 'মধ্যে', 'কোনো', 'অন্য', 'প্রতিটি', 'একটি', 'যেখানে', 'যত', 'যে', 'যদি', 'আর', 'অনেক', 'যেমন', 'যেমন', 'তার', 'ভেতরে', 'দ্বারা', 'এর', 'আছে', 'দিয়ে', 'যাওয়া', 'আসা', 'যে', 'নতুন', 'পুরানো', 'যেমন', 'ফিরে', 'পরের', 'সকল', 'তাদের', 'সব', 'অন্যান্য', 'আরও', 'কোন', 'এখানে', 'যখন', 'তবে', 'তাদের', 'ফিরে', 'যেখানে', 'আরও', 'আমরা', 'কিছু', 'অন্য', 'নতুন', 'কিছু', 'অন্য', 'সবার', 'অপর', 'মাঝে', 'বিভিন্ন', 'এই', 'তাদের', 'আমাদের', 'এই', 'যেমন', 'অতএব', 'এরপর', 'নতুন', 'সর্বোচ্চ', 'সর্বনিম্ন', 'মাঝে', 'অতএব', 'অথচ', 'অথবা', 'অনুযায়ী', 'অনেক', 'অনেকে', 'অনেকেই', 'অন্তত', 'অন্য', 'অবধি', 'অবশ্য', 'অর্থাত', 'আই', 'আগামী', 'আগে', 'আগেই', 'আছে', 'আজ', 'আদ্যভাগে', 'আপনার', 'আপনি', 'আবার', 'আমরা', 'আমাকে', 'আমাদের', 'আমার', 'আমি', 'আর', 'আরও', 'ই', 'ইত্যাদি', 'ইহা', 'উচিত', 'উত্তর', 'উনি', 'উপর', 'উপরে', 'এ', 'এঁদের', 'এঁরা', 'এই', 'একই', 'একটি', 'একবার', 'একে', 'এক্', 'এখন', 'এখনও', 'এখানে', 'এখানেই', 'এটা', 'এটাই', 'এটি', 'এত', 'এতটাই', 'এতে', 'এদের', 'এব', 'এবং', 'এবার', 'এমন', 'এমনকী', 'এমনি', 'এর', 'এরা', 'এল', 'এস', 'এসে', 'ঐ', 'ও', 'ওঁদের', 'ওঁর', 'ওঁরা', 'ওই', 'ওকে', 'ওখানে', 'ওদের', 'ওর', 'ওরা', 'কখনও', 'কত', 'কবে', 'কমনে', 'কয়েক', 'কয়েকটি', 'করছে', 'করছেন', 'করতে', 'করবে', 'করবেন', 'করলে', 'করলেন', 'করা', 'করাই', 'করায়', 'করার', 'করি', 'করিতে', 'করিয়া', 'করিয়ে', 'করে', 'করেই', 'করেছিলেন', 'করেছে', 'করেছেন', 'করেন', 'কাউকে', 'কাছ', 'কাছে', 'কাজ', 'কাজে', 'কারও', 'কারণ', 'কি', 'কিংবা', 'কিছু', 'কিছুই', 'কিন্তু', 'কী', 'কে', 'কেউ', 'কেউই', 'কেখা', 'কেন', 'কোটি', 'কোন', 'কোনও', 'কোনো', 'ক্ষেত্রে', 'কয়েক', 'খুব', 'গিয়ে', 'গিয়েছে', 'গিয়ে', 'গুলি', 'গেছে', 'গেল', 'গেলে', 'গোটা', 'চলে', 'চান', 'চায়', 'চার', 'চালু', 'চেয়ে', 'চেষ্টা', 'ছাড়া', 'ছাড়াও', 'ছিল', 'ছিলেন', 'জন', 'জনকে', 'জনের', 'জন্য', 'জন্যওজে', 'জানতে', 'জানা', 'জানানো', 'জানায়', 'জানিয়ে', 'জানিয়েছে', 'জে', 'জ্নজন', 'টি', 'ঠিক', 'তখন', 'তত', 'তথা', 'তবু', 'তবে', 'তা', 'তাঁকে', 'তাঁদের', 'তাঁর', 'তাঁরা', 'তাঁাহারা', 'তাই', 'তাও', 'তাকে', 'তাতে', 'তাদের', 'তার', 'তারপর', 'তারা', 'তারৈ', 'তাহলে', 'তাহা', 'তাহাতে', 'তাহার', 'তিনঐ', 'তিনি', 'তিনিও', 'তুমি', 'তুলে', 'তেমন', 'তো', 'তোমার', 'থাকবে', 'থাকবেন', 'থাকা', 'থাকায়', 'থাকে', 'থাকেন', 'থেকে', 'থেকেই', 'থেকেও', 'দিকে', 'দিতে', 'দিন', 'দিয়ে', 'দিয়েছে', 'দিয়েছেন', 'দিলেন', 'দু', 'দুই', 'দুটি', 'দুটো', 'দেওয়া', 'দেওয়ার', 'দেওয়া', 'দেখতে', 'দেখা', 'দেখে', 'দেন', 'দেয়', 'দ্বারা', 'ধরা', 'ধরে', 'ধামার', 'নতুন', 'নয়', 'না', 'নাই', 'নাকি', 'নাগাদ', 'নানা', 'নিজে', 'নিজেই', 'নিজেদের', 'নিজের', 'নিতে', 'নিয়ে', 'নিয়ে', 'নেই', 'নেওয়া', 'নেওয়ার', 'নেওয়া', 'নয়', 'পক্ষে', 'পর', 'পরে', 'পরেই', 'পরেও', 'পর্যন্ত', 'পাওয়া', 'পাচ', 'পারি', 'পারে', 'পারেন', 'পি', 'পেয়ে', 'পেয়্র্', 'প্রতি', 'প্রথম', 'প্রভৃতি', 'প্রযন্ত', 'প্রাথমিক', 'প্রায়', 'প্রায়', 'ফলে', 'ফিরে', 'ফের', 'বক্তব্য', 'বদলে', 'বন', 'বরং', 'বলতে', 'বলল', 'বললেন', 'বলা', 'বলে', 'বলেছেন', 'বলেন', 'বসে', 'বহু', 'বা', 'বাদে', 'বার', 'বি', 'বিনা', 'বিভিন্ন', 'বিশেষ', 'বিষয়টি', 'বেশ', 'বেশি', 'ব্যবহার', 'ব্যাপারে', 'ভাবে', 'ভাবেই', 'মতো', 'মতোই', 'মধ্যভাগে', 'মধ্যে', 'মধ্যেই', 'মধ্যেও', 'মনে', 'মাত্র', 'মাধ্যমে', 'মোট', 'মোটেই', 'যখন', 'যত', 'যতটা', 'যথেষ্ট', 'যদি', 'যদিও', 'যা', 'যাঁর', 'যাঁরা', 'যাওয়া', 'যাওয়ার', 'যাওয়া', 'যাকে', 'যাচ্ছে', 'যাতে', 'যাদের', 'যান', 'যাবে', 'যায়', 'যার', 'যারা', 'যিনি', 'যে', 'যেখানে', 'যেতে', 'যেন', 'যেমন', 'র', 'রকম', 'রয়েছে', 'রাখা', 'রেখে', 'লক্ষ', 'শুধু', 'শুরু', 'সঙ্গে', 'সঙ্গেও', 'সব', 'সবার', 'সমস্ত', 'সম্প্রতি', 'সহ', 'সহিত', 'সাধারণ', 'সামনে', 'সি', 'সুতরাং', 'সে', 'সেই', 'সেখান', 'সেখানে', 'সেটা', 'সেটাই', 'সেটাও', 'সেটি', 'স্পষ্ট', 'স্বয়ং', 'হইতে', 'হইবে', 'হইয়া', 'হওয়া', 'হওয়ায়', 'হওয়ার', 'হচ্ছে', 'হত', 'হতে', 'হতেই', 'হন', 'হবে', 'হবেন', 'হয়', 'হয়তো', 'হয়নি', 'হয়ে', 'হয়েই', 'হয়েছিল', 'হয়েছে', 'হয়েছেন', 'হল', 'হলে', 'হলেই', 'হলেও', 'হলো', 'হাজার', 'হিসাবে', 'হৈলে', 'হোক', 'হয়']

def remove_stopwords(text):
    words = nltk.word_tokenize(text)
    filtered_words = [word for word in words if word not in bn_stopwords]
    return ' '.join(filtered_words)

def remove_non_bangla_words(text):
    return ' '.join([word for word in text.split() if all('ঀ' <= c <= '৿' for c in word)])

def remove_null_characters(text):
    return text.replace('\x00', '')

def remove_urls(text):
    url_pattern = re.compile(r'https?://\S+|www\.\S+')
    return url_pattern.sub(r'', text)

def replace_emojis(text):
    for emoji, meaning in emoji_dict.items():
        text = text.replace(emoji, meaning)
    return text

def preprocess_text(text):
    text = replace_emojis(text)
    text = remove_stopwords(text)
    text = remove_non_bangla_words(text)
    text = remove_null_characters(text)
    text = remove_urls(text)
    return text
